;______________________________________________________
;**** PROGRAMMA GESTIONE FUCILE ELETTROMAGNETICO ******
;************** MAGGIO 2009 ***************************
;************ BY MARCO MASSARI ************************
;______________________________________________________

;DATI PER ASSEMBLATORE ********************************
PROCESSOR 12F508      ;PIC 12F508
RADIX HEX             ;NUMERI FORNITI ESADECIMALI
INCLUDE "P12F508.INC" ;INCLUDE DATI ASSEMBLAGGIO
;******************************************************

;**************DICHIARAZIONI VARIABILI******************
ACTCARICA EQU 0X07 ;MEMORIZZA STATO PRECEDENTE CARICA FUCILE
COUNT EQU 0X08 ;VARIABILE CONTATORE DI RITARDO 
;*******************************************************

;**************INIZIALIZZAZIONE PROGRAMMA**************
MOVLW 0XCB ;METTE IN W LA DISPOSIZIONE DI I/O (BIN 11001011)
TRIS GPIO  ;CONFIGURA I/O (1 INGRESSO, 0 USCITA)
MOVLW 0X9F ;CONFIGURA OPTION REGISTER  (BIN 10011111)
OPTION     ;PER ATTIVARE RESISTENZE PULL-UP SU GP0,GP1,GP3
CLRF GPIO  ;RESETTA I/O
CLRF ACTCARICA ;RESETTA STATO CARICA
CLRF COUNT ;RESETTA CONTATORE RITARDO

;**************PROGRAMMA******************************
MAINLOOP   ;CICLO PRINCIPALE
BTFSS GPIO,0 ;TESTA PULSANTE CARICA (LOGICA INVERSA)
CALL WAITPCARICA ;CHIAMA LA SUBROUTINE
BTFSS GPIO,1 ;TESTA PULSANTE SCARICA (LOGICA INVERSA)
CALL WAITPSCARICA ;CHIAMA LA SUBROUTINE
BTFSC ACTCARICA,0 ;SE IL BIT 0 DI ACTCARICA                   
BSF GPIO,4        ;E' A 1 ATTIVA RELE' CARICA
BTFSC ACTCARICA,0 ;STESSA COSA PER IL LED DI SEGNALAZIONE
BSF GPIO,2
BTFSS ACTCARICA,0 ;SE BIT 0 DI ACTCARICA E' A 0 
BCF GPIO,4        ;DISATTIVA SIA RELE' CHE LED DI SEGNALAZIONE
BTFSS ACTCARICA,0
BCF GPIO,2
GOTO MAINLOOP ;RIPETE IL CICLO DALL'INIZIO

WAITPCARICA ;SUBROUTINE PULSANTE CARICA
INCFSZ COUNT ;ATTENDE CHE COUNT SIA ARRIVATO A 0
GOTO WAITPCARICA ;QUESTO CREA UN RITARDO COME ANTIRIMBALZO
BTFSC GPIO,0 ;FINO A CHE IL PULSANTE NON VIENE RILASCIATO (LOGICA INVERSA)
CALL INVERT ;IL PROGRAMMA RIMANE FERMO, ALTRIMENTI VA ALLA SUB
BTFSC GPIO,0 ;DOPO LA SUB SE IL PULSANTE E' STATO RILASCIATO
RETURN ;RITORNA AL CICLO PRINCIPALE
GOTO WAITPCARICA ;SE SALTA ENTRAMBI I TEST PRECEDENTI RIPETE LA SUB

INVERT ;SUB DI INVERSIONE STATO RELE' CARICA
BCF GPIO,5 ;RESETTA STATO USCITA SCARICA
COMF ACTCARICA,W ;PRENDE ACTCARICA E NE SALVA IL COMPLEMENTO IN W
MOVWF ACTCARICA ;SCRIVE IL RISULTATO IN ACTCARICA
RETURN ;RITORNA AL CICLO WAITCARICA

WAITPSCARICA ;SUB PULSANTE SCARICA
INCFSZ COUNT ;ATTENDE CHE COUNT SIA ARRIVATO A 0
GOTO WAITPSCARICA ;QUESTO CREA UN RITARDO COME ANTIRIMBALZO
BTFSC GPIO,1 ;FINO A CHE IL PULSANTE NON VIENE RILASCIATO (LOGICA INVERSA)
CALL TESTON ;IL PROGRAMMA RIMANE FERMO, ALTRIMENTI VA ALLA SUB
BTFSC GPIO,1 ;DOPO LA SUB SE IL PULSANTE E' STATO RILASCIATO
RETURN ;RITORNA AL CICLO PRINCIPALE
GOTO WAITPSCARICA ;SE SALTA ENTRAMBI I TEST PRECEDENTI RIPETE LA SUB

TESTON ;SUB ATTIVAZIONE USCITA SCARICA
BTFSS GPIO,4 ;SE CARICA E' SETTATO SALTA L'ATTIVAZIONE
BSF GPIO,5 ;ALTRIMENTI ATTIVA LA SCARICA DEI CONDENSATORI
RETURN ;RITORNA AL CICLO WAITPSCARICA

END ;TERMINE PROGRAMMA 
